github.com/solanum-ircd/solanum
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 
owen 5cf4519c74 Update 'librb/src/poll.c' 6 months ago
authd Undo overzealous seddery 8 months ago
bandb bandb: remove embedded sqlite 7 months ago
doc add ConfigFileEntry.oper_secure_only, to require TLS to oper up (#76) 7 months ago
extensions extensions: remove m_roleplay 7 months ago
help Get rid of hub_mask/leaf_mask 7 months ago
include add ConfigFileEntry.oper_secure_only, to require TLS to oper up (#76) 7 months ago
ircd chmode: end the grace period more intelligently (#84) 7 months ago
librb Update 'librb/src/poll.c' 6 months ago
m4 Innovation by sed 8 months ago
modules chmode: end the grace period more intelligently (#84) 7 months ago
scripts Innovation by sed 8 months ago
ssld Innovation by sed 8 months ago
tests Add some tests for multiline 7 months ago
testsuite Get rid of hub_mask/leaf_mask 7 months ago
tools Innovation by sed 8 months ago
wsockd Innovation by sed 8 months ago
.appveyor-build.sh Innovation by sed 8 months ago
.appveyor.yml Innovation by sed 8 months ago
.drone.yml restore working drone.yml 6 months ago
.gitignore Update .gitignore for 25d169b649 (#69) 7 months ago
.mailmap mailmap: Sam is Christine now apparently. 5 years ago
.travis.yml bandb: remove embedded sqlite 7 months ago
CREDITS Update credits 8 months ago
LICENSE Remove more $Id tags. 5 years ago
Makefile.am Remove *.la from install/lib 8 months ago
NEWS.md Update news 8 months ago
README.md Update 'README.md' 6 months ago
autogen.sh *sigh* comment these out until travis is fixed. 5 years ago
configure.ac bandb: remove embedded sqlite 7 months ago
shtool Add these for now until travis actually gets their shit together. 5 years ago

README.md

solanum Build Status

Solanum is an IRCv3 server designed to be highly scalable. It implements IRCv3.1 and some parts of IRCv3.2.

It is meant to be used with an IRCv3-capable services implementation such as Atheme or Anope.

necessary requirements

  • A supported platform
  • A working dynamic library system
  • A working lex and yacc - flex and bison should work

platforms

Solanum is designed with portability in mind, but does not target older systems nor those of solely academic interest.

Do note that operating systems are only supported if they are supported by their vendor.

Tier 1

These platforms are the best supported, and should always work. They are actively tested. If you encounter problems, please file a bug.

  • FreeBSD 10.x and above (i386 and amd64)
  • Linux 2.6.x and above with glibc or musl (i386, x86_64, and ARM)
  • macOS 10.7 and above
  • Windows Vista/Server 2008 and above (x86 or x64)

Tier 2

These platforms are supported and occasionally tested, and most features should work, but this is not guaranteed. If you find any problems, file a bug, but as these are not regularly tested platforms, a timely resolution may not be possible.

  • DragonflyBSD 4.4 and above (i386)
  • Linux with uClibc (i386 or x86_64)
  • NetBSD 6.1.x and above (i386, amd64)
  • OpenBSD 5.6 and above (i386, amd64)
  • Solaris 10 and above (i386)

Tier 3

Anything else that hasn't been tested. Solanum may or may not work on it; patches welcome if they don't.

platform specific errata

These are known issues and workarounds for supported platforms.

  • macOS: you must set the LIBTOOLIZE environment variable to point to glibtoolize before running autogen.sh:

    brew install libtool
    export LIBTOOLIZE="/usr/local/bin/glibtoolize"
    ./autogen.sh
    
  • FreeBSD: if you are compiling with ipv6 you may experience problems with ipv4 due to the way the socket code is written. To fix this you must: "sysctl net.inet6.ip6.v6only=0"

  • Solaris: you may have to set your PATH to include /usr/gnu/bin and /usr/gnu/sbin before /usr/bin and /usr/sbin. Solaris's default tools don't seem to play nicely with the configure script.

building

./autogen.sh
./configure --prefix=/path/to/installation
make
make check # run tests
make install

See ./configure --help for build options.

feature specific requirements

  • For SSL/TLS client and server connections, one of:

    • OpenSSL 1.0.0 or newer (--enable-openssl)
    • LibreSSL (--enable-openssl)
    • mbedTLS (--enable-mbedtls)
    • GnuTLS (--enable-gnutls)
  • For certificate-based oper CHALLENGE, OpenSSL 1.0.0 or newer. (Using CHALLENGE is not recommended for new deployments, so if you want to use a different TLS library, feel free.)

  • For ECDHE under OpenSSL, on Solaris and RHEL/Fedora (and its derivatives such as CentOS) you will need to compile your own OpenSSL on these systems, as they have removed support for ECC/ECDHE. Alternatively, consider using another library (see above).

tips

  • To report bugs in solanum, visit us at chat.freenode.net #solanum

  • Please read doc/index.txt to get an overview of the current documentation.

  • Read the NEWS file for what's new in this release.

  • The files, /etc/services, /etc/protocols, and /etc/resolv.conf, SHOULD be readable by the user running the server in order for ircd to start with the correct settings. If these files are wrong, solanum will try to use 127.0.0.1 for a resolver as a last-ditch effort.

git access

  • The Solanum GIT repository can be checked out using the following command: git clone https://github.com/solanum-ircd/solanum

  • Solanum's GIT repository depot can be browsed over the Internet at the following address: https://github.com/solanum-ircd/solanum